import numpy as np
import cv2

img1 = cv2.imread('church.jpg',0) # queryImage
img2 = cv2.imread('church_part.jpg',0) # trainImage

# Initiate SIFT detector
orb = cv2.ORB()

# find the keypoints and descriptors with SIFT
kp1, des1 = orb.detectAndCompute(img1,None)
kp2, des2 = orb.detectAndCompute(img2,None)

# create BFMatcher object
bf = cv2.BFMatcher(cv2.NORM_HAMMING, crossCheck=True)

# Match descriptors.
matches = bf.match(des1,des2)

# Sort them in the order of their distance.
matches = sorted(matches, key = lambda x:x.distance)

# Draw first 10 matches.
h1, w1 = img1.shape[:2]
h2, w2 = img2.shape[:2]
img3 = np.zeros((max(h1, h2), w1 + w2, 3), np.uint8)
img3[:h1, :w1, 0] = img1
img3[:h2, w1:, 0] = img2
img3[:, :, 1] = img3[:, :, 0]
img3[:, :, 2] = img3[:, :, 0]

for m in matches[:10]:
    # draw the keypoints
    # print m.queryIdx, m.trainIdx, m.distance
    color = tuple([np.random.randint(0, 255) for _ in xrange(3)])
    cv2.line(img3, (int(kp1[m.queryIdx].pt[0]), int(kp1[m.queryIdx].pt[1])) , (int(kp2[m.trainIdx].pt[0] + w1), int(kp2[m.trainIdx].pt[1])), color)

cv2.imshow("result", img3)
cv2.waitKey()
